/*
 * Kangaroo Punch MultiPlayer Game Server Mark II
 * Copyright (C) 2020-2021  Scott Duensing
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 *
 */

#include "comport.h"
#include "timer.h"
#include "config.h"


void comPacketSender(char *data, uint32_t length, void *userData) {
	(void)userData;

	comWrite(__configData.serialCom - 1, data, length);
}


int comReceiveBufferFlush(int com) {
	char buffer[256];
	int  result = 1;

	while (result > 0) {
		result = comRead(com, buffer, 255);
	}

	return result;
}


/*
TASKBEGIN(comWaitWithTimeout)
	int32_t  r;
	uint32_t quarterTicks;
	int32_t  count;
	int32_t  bufferIndex;
	char     incoming[2];
	ComWaitWithTimeoutT *args;

	taskCode({
		// Returns number of bytes read into buffer.
		// Value is positive if "expect" was found.
		// Value is negative if not found.

		logWrite("Entering comWaitWithTimeout\n");

		self->args = (ComWaitWithTimeoutT *)data;

		while (self->quarterTicks <= self->args->quarterSeconds) {

	//		logWrite("Calling comRead\n");
			self->r = comRead(self->args->com, self->incoming, 1);
	//		logWrite("Back from comRead with %d\n", self->r);

			if (self->r == 1) {
				self->args->buffer[self->bufferIndex++] = self->incoming[0];
				self->args->buffer[self->bufferIndex]   = 0;
				if (self->incoming[0] == self->args->expecting[self->count]) {
					self->count++;
					if (self->count == (int)strlen(self->args->expecting)) {
						// Found our expect.
						break;
					}
				} else {
					self->count = 0;
				}
				if (self->bufferIndex == self->args->len - 1) {
					// Out of buffer.
					break;
				}
			}

	//		logWrite("Yielding from comWaitWithTimeout\n");
			taskYield();
	//		logWrite("Back in comWaitWithTimeout\n");

			if (__timerQuarterSecondTick) {
				self->quarterTicks++;
				logWrite("Tick\n");
			}
		}

		logWrite("Exiting comWaitWithTimeout\n");

		if (self->count == (int)strlen(self->args->expecting)) {
			self->args->result = self->bufferIndex;
		}

		self->args->result = -self->bufferIndex;
	});
TASKEND
*/
